function rejidx = JT_LM(MDS,K,alpha)

%Name:      JT_LM
%Purpose:   Jump Test by Lee and Mykland
%Format:    rejidx = JT_LM(MDS,K,alpha)
%
%Note: I ignore the drift function
%2009-06-01             By Yongok Choi
%Version 1.0 

n   = length(MDS);
Li  = zeros(n,1);
stat= zeros(n,1);

    for i = K:1:n;
        sg2     = 1/(K-2)*sum(abs(MDS(i-K+1:i-2,1)).*abs(MDS(i-K+2:i-1,1)));
        Li(i,1) = MDS(i)/sqrt(sg2);
        c       = sqrt(2)/sqrt(pi);
        Cn      = (2*log(n))^0.5/c - (log(pi) + log(log(n)))/(2*c*(2*log(n))^0.5);
        Sn      = 1/(c*(2*log(n))^0.5);
        stat(i,1) = (abs(Li(i,1))-Cn)/Sn;     
    end
    
    cv      = - log (-log(1-alpha));
    rejidx  = stat > cv;
return;