function g = LL_reg(Y,X,h,tic)

%Name:      LL_reg(Local Linear Regression Fit)
%Purpose:   Getting Local Linear regression Model coefficients 
%Format:    g = LL_reg(Y,X,h,tic)
%
%2010-08-23             By Yongok Choi
%Version 1.0 

n   = length(X);
ticn= length(tic);
g   = zeros(ticn,2);

for i=1:1:ticn
    z = (tic(i)-X);
    w = normpdf(z/h,0,1);
    xx11 = sum(ones(n,1).*w.*ones(n,1));
    xx12 = sum(ones(n,1).*w.*z);
    xx22 = sum(z.*w.*z);
    invx = inv([xx11 xx12;xx12 xx22]);
    xwy1 = sum(ones(n,1).*w.*Y);
    xwy2 = sum(z.*w.*Y);
    bhat = invx*[xwy1;xwy2];
    g(i,:) = bhat';    
end

return
