function h = RoTBw_LL(Y,X)

%Name:      RoTBw_LL(Rule of Thumb Bandwidth Selection for Local Linear
%Model)
%Purpose:   Compute Rule of Thumb Bandwidth for Local Linear Model 
%Format:    h = RoTBw_LL(Y,X)
%
%2010-08-23             By Yongok Choi
%Version 1.0 
%Note: 
%Reference: Local Polynomial Modeling and its application(by J. Fan and I. Gijbels, p 111)
% with w_0: Indicate Function on 

n   = length(X);
x   = [ones(n,1) X X.^2 X.^3 X.^4];

min_x = min(X);
max_x = max(X);

beta = (x'*x)\(x'*Y);
e    = (Y-x*beta);
 mse = e'*e/n;
 mp1 = [2*ones(n,1) 6*X 12*(X.^2)]*beta(3:5,1);
   h = 0.776*(((mse*(max_x-min_x)))/sum(mp1.^2))^0.2;

return

