function Wald = FFT_CAPM_woJ(hprx_vw,Mkt)

[m,n]   = size(hprx_vw); % m: # of rows, n: # of columns

Y       = hprx_vw;
X       = [1/252*100*ones(m,1) Mkt];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Step3: For each i=1, ... , 10, estimate betas by running OLS over Monthly
% data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

BigBhat = inv(X'*X)*X'*Y;
BigBhatT = BigBhat';
BetaRst_1=[ BigBhatT(:,1);0;0;mean(BigBhatT(:,1));std(BigBhatT(:,1)) ];
BetaRst_2=[ BigBhatT(:,2);0;0;mean(BigBhatT(:,2));std(BigBhatT(:,2)) ];
BetaRst = [BetaRst_1 BetaRst_2];
Uhat    = Y - X*BigBhat;

[nr,nc]     = size(X);
s2          = sum(Uhat.^2,1)/(nr-nc);
Bigse       = sqrt(diag(inv(X'*X))*s2);
BigseT      = Bigse';

BigEstRst   = zeros(n,nc*2);
for i=1:1:nc;
    BigEstRst(:,2*(i-1)+1) = BigBhatT(:,i);
    BigEstRst(:,2*(i-1)+2) = BigseT(:,i);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Step5: Estimate error variance matrix
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Sigmahat    = Uhat(:,1:n)'*Uhat(:,1:n)/length(Uhat);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Step6: Calcuate Wald statistic
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

X1 = X(:,1);
X2 = X(:,2);

star = inv(X1'*X1-X1'*X2*inv(X2'*X2)*X2'*X1);
Wald = inv(star)*BigBhat(1,:)*inv(Sigmahat)*BigBhat(1,:)';

% fprintf('\n H_0: alpha_i = 0 for all i.');
% fprintf('\n Wald statistic is                   %10.4f. ', Wald);
% fprintf('\n p-value from Wald statistic is      %10.4f. \n',1-chi2cdf(Wald,n));       

