clc;clear;
tic;

N_sim       = 10000;  
Sim_rst     = zeros(N_sim,20);

delta       = 1/252;
subdelta    = 1;%1/6;
nsiy        = 1/delta*1/subdelta;
nsim        = 1/subdelta*21;
nsid        = 1/subdelta; 

seed        = 4956000;
stream      = RandStream('mt19937ar', 'Seed', seed);
RandStream.setGlobalStream(stream);

Size_Rst    = zeros(36,5);
Pct_95      = zeros(12,6);

Case = 1;

for T= 20;
    for c= [0 1 3 5];
        for v = [0.1 0.5 1];
            Sim_rst     = zeros(N_sim,6);
            for j =1:1:N_sim                
            ns          = (T/delta)/subdelta;
            v_1         = v;
            v_2         = v;
            dVW         = randn(ns,2)*sqrt(delta*subdelta);
            dZs         = randn(ns,2)*sqrt(delta*subdelta);   
            V_t         = [0;cumsum(dVW(:,1))];
            W_t         = [0;cumsum(dVW(:,2))];
            s_t         = 1+5*abs(V_t+c*W_t);
            dV_t        = dVW(:,1);
            dW_t        = dVW(:,2);

            dX_t        = s_t(1:end-1,1).*dV_t;
            dU_1t       = s_t(1:end-1,1).*(dW_t+v_1*dZs(:,1));
            dU_2t       = s_t(1:end-1,1).*(dW_t+v_2*dZs(:,2));
            dY1_t       = dU_1t;
            dY2_t       = dU_2t;
            Date    = kron((1:1:T)'+1962,ones(nsiy,1))*10000+repmat(kron((1:1:12)',ones(nsim,1)),T,1)*100+repmat(kron((1:1:21)',ones(nsid,1)),T*12,1);

            dY_t        = [dY1_t dY2_t];
            Sim_rst(j,1) = FT_CAPM_woJ(dY_t,Date,dX_t);
            Sim_rst(j,2) = 1-chi2cdf(Sim_rst(j,1),2);
            Sim_rst(j,3) = FFT_CAPM_woJ(dY_t,dX_t);
            Sim_rst(j,4) = 1-chi2cdf(Sim_rst(j,3),2);
            Sim_rst(j,5) = TC_CAPM_woJ(dY_t,Date,dX_t);
            Sim_rst(j,6) = 1-chi2cdf(Sim_rst(j,5),2);            
            end

            Size_Rst((Case-1)*3+1,1)=T;
            Size_Rst((Case-1)*3+2,1)=T;
            Size_Rst((Case-1)*3+3,1)=T;     
            
            Size_Rst((Case-1)*3+1,2)=c;
            Size_Rst((Case-1)*3+2,2)=c;
            Size_Rst((Case-1)*3+3,2)=c;       
            
            Size_Rst((Case-1)*3+1,3)=v;
            Size_Rst((Case-1)*3+2,3)=v;
            Size_Rst((Case-1)*3+3,3)=v;               

            Size_Rst((Case-1)*3+1,4)=mean(Sim_rst(:,2) < 0.01);
            Size_Rst((Case-1)*3+2,4)=mean(Sim_rst(:,2) < 0.05);
            Size_Rst((Case-1)*3+3,4)=mean(Sim_rst(:,2) < 0.1);

            Size_Rst((Case-1)*3+1,5)=mean(Sim_rst(:,4) < 0.01);
            Size_Rst((Case-1)*3+2,5)=mean(Sim_rst(:,4) < 0.05);
            Size_Rst((Case-1)*3+3,5)=mean(Sim_rst(:,4) < 0.1);
            
            Size_Rst((Case-1)*3+1,6)=mean(Sim_rst(:,6) < 0.01);
            Size_Rst((Case-1)*3+2,6)=mean(Sim_rst(:,6) < 0.05);
            Size_Rst((Case-1)*3+3,6)=mean(Sim_rst(:,6) < 0.1);            
            
            Pct_95(Case,1)=T;
            Pct_95(Case,2)=c;
            Pct_95(Case,3)=v;
            Pct_95(Case,4:6)=prctile([Sim_rst(:,1) Sim_rst(:,3) Sim_rst(:,5)],95);
            Case = Case+1;
        end
    end
end

save('size_T20_panel_FFT.mat','Size_Rst');
save('pct95_T20_panel_FFT.mat','Pct_95');


toc;

Tex_Size_Rst_T20 = zeros(4,12);

for i=1:1:4;
    Tex_Size_Rst_T20(i,1:3:4) = Size_Rst((i-1)*9+2:(i-1)*9+3,4);
    Tex_Size_Rst_T20(i,2:3:5) = Size_Rst((i-1)*9+2:(i-1)*9+3,5);
    Tex_Size_Rst_T20(i,3:3:6) = Size_Rst((i-1)*9+2:(i-1)*9+3,6);
    Tex_Size_Rst_T20(i,7:3:10) = Size_Rst((i-1)*9+8:(i-1)*9+9,4);
    Tex_Size_Rst_T20(i,8:3:11) = Size_Rst((i-1)*9+8:(i-1)*9+9,5);
    Tex_Size_Rst_T20(i,9:3:12) = Size_Rst((i-1)*9+8:(i-1)*9+9,6);    
end

seed        = 4956000;
stream      = RandStream('mt19937ar', 'Seed', seed);
RandStream.setGlobalStream(stream);

Size_Rst    = zeros(36,5);
Pct_95      = zeros(12,6);

Case = 1;

for T= 50;
    for c= [0 1 3 5];
        for v = [0.1 0.5 1];
            Sim_rst     = zeros(N_sim,6);
            for j =1:1:N_sim                
            ns          = (T/delta)/subdelta;
            v_1         = v;
            v_2         = v;
            dVW         = randn(ns,2)*sqrt(delta*subdelta);
            dZs         = randn(ns,2)*sqrt(delta*subdelta);   
            V_t         = [0;cumsum(dVW(:,1))];
            W_t         = [0;cumsum(dVW(:,2))];
            s_t         = 1+5*abs(V_t+c*W_t);
            dV_t        = dVW(:,1);
            dW_t        = dVW(:,2);

            dX_t        = s_t(1:end-1,1).*dV_t;
            dU_1t       = s_t(1:end-1,1).*(dW_t+v_1*dZs(:,1));
            dU_2t       = s_t(1:end-1,1).*(dW_t+v_2*dZs(:,2));
            dY1_t       = dU_1t;
            dY2_t       = dU_2t;
            Date    = kron((1:1:T)'+1962,ones(nsiy,1))*10000+repmat(kron((1:1:12)',ones(nsim,1)),T,1)*100+repmat(kron((1:1:21)',ones(nsid,1)),T*12,1);

            dY_t        = [dY1_t dY2_t];
            Sim_rst(j,1) = FT_CAPM_woJ(dY_t,Date,dX_t);
            Sim_rst(j,2) = 1-chi2cdf(Sim_rst(j,1),2);
            Sim_rst(j,3) = FFT_CAPM_woJ(dY_t,dX_t);
            Sim_rst(j,4) = 1-chi2cdf(Sim_rst(j,3),2);
            Sim_rst(j,5) = TC_CAPM_woJ(dY_t,Date,dX_t);
            Sim_rst(j,6) = 1-chi2cdf(Sim_rst(j,5),2);            
            end

            Size_Rst((Case-1)*3+1,1)=T;
            Size_Rst((Case-1)*3+2,1)=T;
            Size_Rst((Case-1)*3+3,1)=T;     
            
            Size_Rst((Case-1)*3+1,2)=c;
            Size_Rst((Case-1)*3+2,2)=c;
            Size_Rst((Case-1)*3+3,2)=c;       
            
            Size_Rst((Case-1)*3+1,3)=v;
            Size_Rst((Case-1)*3+2,3)=v;
            Size_Rst((Case-1)*3+3,3)=v;               

            Size_Rst((Case-1)*3+1,4)=mean(Sim_rst(:,2) < 0.01);
            Size_Rst((Case-1)*3+2,4)=mean(Sim_rst(:,2) < 0.05);
            Size_Rst((Case-1)*3+3,4)=mean(Sim_rst(:,2) < 0.1);

            Size_Rst((Case-1)*3+1,5)=mean(Sim_rst(:,4) < 0.01);
            Size_Rst((Case-1)*3+2,5)=mean(Sim_rst(:,4) < 0.05);
            Size_Rst((Case-1)*3+3,5)=mean(Sim_rst(:,4) < 0.1);
            
            Size_Rst((Case-1)*3+1,6)=mean(Sim_rst(:,6) < 0.01);
            Size_Rst((Case-1)*3+2,6)=mean(Sim_rst(:,6) < 0.05);
            Size_Rst((Case-1)*3+3,6)=mean(Sim_rst(:,6) < 0.1);            
            
            Pct_95(Case,1)=T;
            Pct_95(Case,2)=c;
            Pct_95(Case,3)=v;
            Pct_95(Case,4:6)=prctile([Sim_rst(:,1) Sim_rst(:,3) Sim_rst(:,5)],95);
            Case = Case+1;
        end
    end
end

save('size_T50_panel_FFT.mat','Size_Rst');
save('pct95_T50_panel_FFT.mat','Pct_95');

toc;

Tex_Size_Rst_T50 = zeros(4,12);

for i=1:1:4;
    Tex_Size_Rst_T50(i,1:3:4) = Size_Rst((i-1)*9+2:(i-1)*9+3,4);
    Tex_Size_Rst_T50(i,2:3:5) = Size_Rst((i-1)*9+2:(i-1)*9+3,5);
    Tex_Size_Rst_T50(i,3:3:6) = Size_Rst((i-1)*9+2:(i-1)*9+3,6);
    Tex_Size_Rst_T50(i,7:3:10) = Size_Rst((i-1)*9+8:(i-1)*9+9,4);
    Tex_Size_Rst_T50(i,8:3:11) = Size_Rst((i-1)*9+8:(i-1)*9+9,5);
    Tex_Size_Rst_T50(i,9:3:12) = Size_Rst((i-1)*9+8:(i-1)*9+9,6);    
end

Tex_Size_Rst = [Tex_Size_Rst_T20;Tex_Size_Rst_T50];
