% Evaluating Factor Pricing Models Using High Frequency Panels
% by Yoosoon Chang, Yongok Choi, Hagen Kim, Joon Park
%
% Summary Statistics of Factors
% Input: FF_Factors_daily.txt
%           1963.7.1 ~ 2009. 3.31 for the F-F factor
% Output: Panel_A 
%
% 2014-01-31  
% Version 2.0 
% By Yongok Choi (choiyongok@gmail.com)

clear all; close all; clc;
load ('..\..\Data\FF_Factors_daily.txt'); % Fama-French factors and risk-free rate

% 1963-7-1 ~ 2008-12-31 
% FF factors
Mkt = FF_Factors_daily(1:11455,2);              %Market minus risk free rate
SMB = FF_Factors_daily(1:11455,3);              %Small minus Big ME
HML = FF_Factors_daily(1:11455,4);              %High minus Low BE/ME

Factors = [Mkt SMB HML];

Mean   = (mean(Factors,1)*252/100)';
Std    = (std(Factors,1)*sqrt(252)/100)';
Corr   = corr(Factors);

Panel_A = [Mean Std Corr];
