clc;clear;
load ('..\..\Data\FT_MU_FF3FCTR.txt');

Resid_FT = FT_MU_FF3FCTR;

FT_LF    = zeros(size(Resid_FT,1),25);
FT_Vol   = zeros(size(Resid_FT,1),25);
FT_Gamma = zeros(25,2);

FT_rho   = zeros(25,2);
Est_rst = zeros(25,7);
for i = 1:1:25
%------------------------------------------------------
%  ML procedure
%------------------------------------------------------
% Optimization Options
options.LargeScale = 'off';  options.HessUpdate = 'bfgs';
options.Display    = 'iter'; options.MaxFunEvals = 100000;
options.TolFun     = 0.005;
options.FunValCheck= 'on';

init_mu     = 0.01;
init_nu     = 0.03;
init_lambda = 0.4;
init_gamma  = 2.0;
init_alpha  = 0.9;
init_rho    = -0.5;

param   = [log(init_mu);log(init_nu); log(init_lambda); init_gamma; ...
            tan(pi/2*(init_alpha)); tan(pi/2*(init_rho))]; 
        
[parahat_FT, fval_FT, exitflag_FT, output_FT, grad_FT, hessian_FT] =...
          fminunc(@(parahat)Lik_lsv(parahat,Resid_FT(:,i)/100), param, options);
      
% Estimates 
 Est_rst_FT             = Trns_LSV(parahat_FT);

 % Delta Method
 F           = [exp(Est_rst_FT(1,1)) 0 0 0 0 0;
                0 exp(Est_rst_FT(2,1)) 0 0 0 0;
                0 0 exp(Est_rst_FT(3,1)) 0 0 0;
                0 0 0 1 0 0;
                0 0 0 0 2/pi*1/(1+Est_rst_FT(5,1)^2) 0;
                0 0 0 0 0 2/pi*1/(1+Est_rst_FT(6,1)^2)];
var_FT      = F*inv(hessian_FT)*F';
se_FT   	= diag(sqrt(var_FT));         
      
FT_rho(i,1)   =  Est_rst_FT(end,1);
FT_rho(i,2)   =  se_FT(end,1);

% Extracting the Latent Factor
[X_tt, X_tl, PX_tl, PX_tt, Vol, py_tl] = Flt_lsv(parahat_FT,Resid_FT(:,i)/100); 
FT_LF(:,i)   = X_tt;
FT_Vol(:,i)  = Vol;
        
%% Gamma Estimation

TY_FT  = X_tt(2:end,1);
TX_FT  = X_tt(1:end-1,1);

gamma_FT   = inv(TX_FT'*TX_FT)*TX_FT'*TY_FT;
resid_FT   = TY_FT - TX_FT*gamma_FT;

% Newey West HAC Estimator
rX      = (TX_FT.*kron(resid_FT,ones(1,size(TX_FT,2))))';
Q       = rX*rX';
L       = round(4*(size(rX,2)/100)^(2/9));
for l = 1:L;
    cp  = rX(:,(l+1):end)*rX(:,1:end-l)';
    w   = 1 - l/(L+1);
    Q   = Q + w*(cp+cp');
end
var_gamma_FT = inv((TX_FT'*TX_FT))*Q*inv((TX_FT'*TX_FT));
se_gamma_FT  = sqrt(diag(var_gamma_FT));

FT_Gamma(i,1)   =  gamma_FT;
FT_Gamma(i,2)   =  se_gamma_FT;

Est_rst(i,1:6)  = Est_rst_FT';
Est_rst(i,7)    = -fval_FT;

end

savehead = 'LSV_FT';
saveformat1 = '.mat';
save([savehead,saveformat1]); 
