clc;clear;
load ('..\..\Data\RT_MU_FF3FCTR.txt');

Resid_RT = RT_MU_FF3FCTR;

RT_LF    = zeros(size(Resid_RT,1),25);
RT_Vol   = zeros(size(Resid_RT,1),25);
RT_Gamma = zeros(25,2);
RT_rho   = zeros(25,2);
Est_rst = zeros(25,7);

for i =1:1:25
%------------------------------------------------------
%  ML procedure
%------------------------------------------------------
% Optimization Options
options.LargeScale = 'off';  options.HessUpdate = 'bfgs';
options.Display    = 'iter'; options.MaxFunEvals = 100000;
options.TolFun     = 0.005;
options.FunValCheck= 'on';

    init_mu     = 0.01;init_nu     = 0.01;init_lambda = 1;
    init_gamma  = -0.1;init_alpha  = 0.5;init_rho    =  -0.5;

if i == 10
    init_mu     = 0.01;init_nu     = 0.01;init_lambda = 1;
    init_gamma  = -0.1;init_alpha  = 0.3;init_rho    =  0;
elseif i == 16
    init_mu     = 0.01;init_nu     = 0.01;init_lambda = 1;
    init_gamma  = -0.1;init_alpha  = 0.3;init_rho    =  0;    
elseif i== 19
    init_mu     = 0.01;init_nu     = 0.01;init_lambda = 1;
    init_gamma  = -0.1;init_alpha  = 0.3;init_rho    =  -0.5;   
end

param   = [log(init_mu);log(init_nu); log(init_lambda); init_gamma; ...
            tan(pi/2*(init_alpha)); tan(pi/2*(init_rho))];
        
[parahat_RT, fval_RT, exitflag_RT, output_RT, grad_RT, hessian_RT] =...
          fminunc(@(parahat)Lik_lsv(parahat,Resid_RT(:,i)/100), param, options);
      
% Estimates 
 Est_rst_RT             = Trns_LSV(parahat_RT);

 % Delta Method

 F           = [exp(parahat_RT(1,1)) 0 0 0 0 0;
                0 exp(parahat_RT(2,1)) 0 0 0 0;
                0 0 exp(parahat_RT(3,1)) 0 0 0;
                0 0 0 1 0 0;
                0 0 0 0 2/pi*1/(1+parahat_RT(5,1)^2) 0;
                0 0 0 0 0 2/pi*1/(1+parahat_RT(6,1)^2)];            
            
var_RT      = F*inv(hessian_RT)*F';
se_RT   	= diag(sqrt(var_RT));         

RT_rho(i,1)   =  Est_rst_RT(end,1);
RT_rho(i,2)   =  se_RT(end,1);

% Extracting the Latent Factor
[X_tt, X_tl, PX_tl, PX_tt, Vol, py_tl] = Flt_lsv(parahat_RT,Resid_RT(:,i)/100); 
RT_LF(:,i)   = X_tt;
RT_Vol(:,i)  = Vol;
     
% Gamma Estimation

TY_RT  = X_tt(2:end,1);
TX_RT  = X_tt(1:end-1,1);

gamma_RT   = inv(TX_RT'*TX_RT)*TX_RT'*TY_RT;
resid_RT   = TY_RT - TX_RT*gamma_RT;

% Newey West HAC Estimator
rX      = (TX_RT.*kron(resid_RT,ones(1,size(TX_RT,2))))';
Q       = rX*rX';
L       = round(4*(size(rX,2)/100)^(2/9));
for l = 1:L;
    cp  = rX(:,(l+1):end)*rX(:,1:end-l)';
    w   = 1 - l/(L+1);
    Q   = Q + w*(cp+cp');
end
var_gamma_RT = inv((TX_RT'*TX_RT))*Q*inv((TX_RT'*TX_RT));
se_gamma_RT  = sqrt(diag(var_gamma_RT));

RT_Gamma(i,1)   =  gamma_RT;
RT_Gamma(i,2)   =  se_gamma_RT;

Est_rst(i,1:6)  = Est_rst_RT';
Est_rst(i,7)    = -fval_RT;

end

savehead = 'LSV_RT';
saveformat1 = '.mat';
save([savehead,saveformat1]);  