function theta = Trns_LSV(theta)

%Name:      Trns_LSV(transformation for Logistic Stochastic Volatility)
%Purpose:   transform estimates for non-negative condition and some bounds
%Format:    [theta] = Trns_LSV(theta)
%           f(x) = mu + nu/(1+exp(-lambda*x+gamma))
%           mu , nu, lambda >0
%           |alpha| < 1
%           |rho|   < 1
%           theta = (mu nu lambda gamma alpha rho)'
%
%   2012-12-02  
%   Version 2.0 
%   By Yongok Choi (choiyongok@gmail.com)

theta(1:3) = exp(theta(1:3));
theta(5)   = atan(theta(5))*2/pi;
theta(6)   = atan(theta(6))*2/pi;

return;
